<?php 
/* 
   SMF EXIF MOD 
   Version : 1.0
   Date: 2005-06-28 
   By: fatman (fatman_li@yahoo.com.hk) 
    
*/ 



class exif_parser {
	var $filter_control;
	var $field = array();
	var $info = array();
	var $lang = array();
	
	function exif_parser($file) {
		global $txt;
		loadLanguage('exif');

		
		// true: enable the field filter 
		// false: disable the field filter 		
		$this->filter_control = true;
		
		// add the field name for show in exif section 
		$this->field = array ( "Model",
//					"Orientation",
					"Software",
					"ExposureTime",
					"FNumber",
					"ISOSpeedRatings",
//					"ExposureBiasValue",
					"MeteringMode",
					"Flash",
					"FocalLength",
					"DateTimeOriginal",
					"ColorSpace",
//					"ExifImageWidth",
//					"ExifImageLength",
					);	
	     					
		$exif = exif_read_data ($file,'IFD0'); 
		if ($exif) { 
			$exif = exif_read_data ($file,0,true);               
			foreach($exif as $key=>$section) { 
				if (($key == "IFD0") or ($key == "EXIF")) { 
					foreach($section as $name=>$val) { 
						if (!(in_array($name, $this->field)) and $this->filter_control) continue;
						if ($this->filter_control) {
							if (array_key_exists('exif_' . $name, $txt)) {
								$this->info[$txt['exif_' . $name]] = $this->parse_value($name, $val);
							}
							else
							{
								$this->info['NO LANG'] = $this->parse_value($name, $val);
							}
						}
						else {
							$this->info[$name] = $val;
						}
					} 
				} 
          	}
     	}					
		return true;	
	}


	function get_str_val($val) { 
		if ((substr($val, strpos($val, "/") + 1)) == "0") {
			$val = 0;
		} else {
			$val = (substr($val, 0, strpos($val, "/"))) / (substr($val, strpos($val, "/") + 1)); 
		}
		return $val; 
	} 

	function parse_value($name, $val) { 
		global $txt;
		$top = substr($val, 0, strpos($val, "/"));
		$bottom = substr($val, strpos($val, "/") + 1);
		switch($name) { 
		case "Orientation": 
		case "ResolutionUnit": 
		case "YCbCrPositioning": 		
		case "ExposureProgram": 		
		case "MeteringMode": 		
		case "LightSource": 		
		case "Flash": 		
		case "ColorSpace": 		
		case "FocalPlaneResolutionUnit": 		
		case "SensingMethod": 		
			$val = $txt['exif_' . strtolower($name) . '_' . $val];
			break; 
		case "FileSource": 
		case "SceneType": 		
			$val = $txt['exif_' . strtolower($name) . '_' . hexdec(bin2hex($val))];
			break; 			
		case "ExposureTime": 
//			if($top/10 == 1) $val = "1/" . round($bottom/10, 0);
			if((round($bottom/$top,0) - round($bottom/$top,2)) == 0) $val = "1/" . round($bottom/$top,0); 
			if($bottom == 1) $val = $top; 
  			$val = $val . $txt['exif_' . strtolower($name) . '_1']; 
  			break; 
		case "FNumber": 
			$val = "F/" . $this->get_str_val($val); 
			break; 
		case "ExifVersion": 
			$val = round($val / 100, 2); 
			break; 
		case "ComponentsConfiguration": 
			$val = bin2hex($val); 
			$val = str_replace("01","Y",$val); 
			$val = str_replace("02","Cb",$val); 
			$val = str_replace("03","Cr",$val); 
			$val = str_replace("04","R",$val); 
			$val = str_replace("05","G",$val); 
			$val = str_replace("06","B",$val); 
			$val = str_replace("00","",$val);        
			break; 
		case "CompressedBitsPerPixel": 
		case "BrightnessValue": 
			$val = $this->get_str_val($val); 
			break; 
		case "ShutterSpeedValue": 
			$val = "1/" . round(pow(2, $this->get_str_val($val))) . $txt['exif_' . strtolower($name) . '_1']; 
			break; 
		case "ApertureValue": 
			$val = "F/" . round(pow(sqrt(2), $this->get_str_val($val)),1); 
			break; 

		case "ExposureBiasValue": 
			if ($top == "0") { 
				$val = "0" . $txt['exif_' . strtolower($name) . '_1']; 
			} elseif (($bottom % $top) == 0){
				$val = "1/" . ($bottom / $top);
			} else { 
				$tmp_val = $this->get_str_val($val); 
				if ($tmp_val == round($tmp_val, 0))   $val = $tmp_val;
				$val = $val . $txt['exif_' . strtolower($name) . '_1']; 
			} 
			break; 
		case "MaxApertureValue": 
			$val = "F/" . round(pow(sqrt(2), $this->get_str_val($val)),1); 
			break; 
		case "SubjectDistance": 
		case "FocalLength": 
			$val = $this->get_str_val($val) . $txt['exif_' . strtolower($name) . '_1']; 
			break; 
		case "FlashPixVersion": 
  			$val = round($val / 100, 2); 
  			break; 
		case "FocalPlaneXResolution": 
		case "FocalPlaneYResolution": 
			$val = round($this->get_str_val($val)); 
			break;                        

		} 
		return $val; 
	} 
	
	function get_html() {
		$html = ""; 
		foreach($this->info as $name=>$val) { 
			$html .= "<strong>" . $name . ":</strong>" . $val . "&nbsp;&nbsp; ";
     	}
     	return $html;
	}


}
?>
